var sape = sape || {};

if (!sape.addform) sape.addform = {};

sape.addform.onClick = function (aEvent)
{
    var st = sape.toolbar, doc = st.getDocument(), cc = 0, lay = st.layout(doc);

    var pages = doc.getElementById("check-pages-area").value;
    if (!pages.length) return;

    var page = pages.split("\n");

    for (var i = 0; i < page.length; i++)
    {
        var url = page[i].replace(/\r/, "");

        var r = doc.getElementsByTagName("tr");
        for (var j = 0; j < r.length; j++)
        {
            var col = r[j].cells;
            if (col.length < lay.cols) continue;

            var checkbox = st.getCheckbox(col[lay.check]);
            if (!checkbox) continue;

            var a = r[j].getElementsByTagName("a");
            for (var k = 0; k < a.length; k++)
            {
               if ((a[k].getAttribute("href") == url) || (a[k].getAttribute("href") == url.replace(/\/$/, "")))
               {
                   checkbox.checked = true; cc++;
                   break;
               }
            }
        }
    }
    st.showAlert(st.str('nice'), (cc > 0)? st.str('links.checked') + ' ' + cc : st.str('links.nochecked'), 0);
};

sape.addform.add = function()
{
    var st = sape.toolbar, doc = st.getDocument();

    if (doc.querySelector('textarea#check-pages-area')) return;

    var inner = doc.createElement('div');
        inner.className = "inner maincol";
        inner.style.margin = "0px";

    var ef = doc.createElement('div');
        ef.className = "export-form";
        ef.style.marginLeft = "250px";
        inner.appendChild(ef);

    var li = doc.createElement('div');
        li.className = "lining";
        ef.appendChild(li);

    var f_h3 = doc.createElement("h3");
        f_h3.appendChild(doc.createTextNode(st.str('addform.s1')));

    var f_ta = doc.createElement("textarea");
        f_ta.setAttribute("id", "check-pages-area");
        f_ta.setAttribute("name", "check-pages-area");
        f_ta.setAttribute("style", "width:100%; height:150px; margin:10px auto;");

    var f_in = doc.createElement("input");
        f_in.setAttribute("type", "button");
        f_in.setAttribute("value", st.str('addform.s2'));
        f_in.setAttribute("style", "margin:0px auto;");
        f_in.addEventListener("click", sape.addform.onClick, false);

    var f_fs = doc.createElement("fieldset");
        f_fs.className = "exp";
        f_fs.setAttribute("style", "text-align:center;");
        f_fs.appendChild(f_in);

    var form = doc.createElement('form');
        form.appendChild(f_h3);
        form.appendChild(f_ta);
        form.appendChild(f_fs);
        li.appendChild(form);

    var root = doc.querySelector('#content');
    if (root) root.appendChild(inner);
};

