var sape = sape || {};

if (!sape.counters) sape.counters =
{
    inProgress: 0,
    doc: null,
    lay: {},
    lc: -1,
    skip: false,
    img: "chrome://wmsape/skin/traffic.png",
    anonymous: true,
    cache: {},
    workers: ['liru','openstat','metrika','topmail','iua','hotlog']
};

sape.counters.openStat = function()
{
    var st = sape.toolbar, doc = st.getDocument();
    var html = doc.body.innerHTML, URI = st.getURI(doc.location), link = "", exp;

    if (!link)
    {
        exp = /(openstat|spylog)(\d+)/.exec(html);
        if (exp) link = 'http://rating.openstat.ru/site/' + exp[2] + '/';
    }
    if (!link)
    {
        exp = /\.(mail|list)\.ru\/counter\?id\=(\d+)/i.exec(html);
        if (exp) link = 'http://top.mail.ru/rating?id=' + exp[2] + '&period=0';
    }
    if (!link)
    {
        exp = /click\.hotlog\.ru\/\?(\d+)/i.exec(html);
        if (exp) link = 'http://hotlog.ru/viewstat?id=' + exp[1];
    }
    if (!link)
    {
        exp = /hotlog\.ru\/viewstat\?id\=(\d+)/i.exec(html);
        if (exp) link = 'http://hotlog.ru/viewstat?id=' + exp[1];
    }
    if (!link)
    {
        exp = /counter\.rambler\.ru\/top100\.cnt\?(\d+)/i.exec(html);
        if (exp) link = 'http://top100.rambler.ru/resStats/' + exp[1] + '/';
    }
    if (!link)
    {
        exp = /bs\.yandex\.ru\/informer\/(\d+)/.exec(html);
        if (exp) link =  'https://metrika.yandex.ru/stat/?id=' + exp[1] + '&from=informer';
    }
    if (!link)
    {
        exp = /counter\.yadro\.ru\/hit\?/i.exec(html);
        if (exp) link = 'https://www.liveinternet.ru/stat/' + URI.asciiHost + '/';
    }
    if (!link)
    {
        exp = /counter\.yadro\.ru\/hit\;([_a-z0-9]+)\?/i.exec(html);
        if (exp) link = 'https://www.liveinternet.ru/stat/' + exp[1] + '/';
    }
    if (!link)
    {
        exp = /counter\.yadro\.ru\/logo\;([_a-z0-9]+)/i.exec(html);
        if (exp) link = 'https://www.liveinternet.ru/stat/' + exp[1] + '/';
    }
    if (!link)
    {
        exp = /Histats\.start[\(\)]\d+[,](\d+)[,]/i.exec(html);
        if (exp) link = 'http://www.histats.com/viewstats/?SID=' + exp[1];   // histats.com
    }
    if (!link)
    {
        exp = /[\.\s]yaCounter(\d+)/.exec(html);
        if (exp) link =  'https://metrika.yandex.ru/stat/?id=' + exp[1] + '&from=informer';
    }
    if (link)
    {
        openUILinkIn(link, 'tab');
    }
};

sape.counters.farm =
{
    metrika: function(req)
    {
        var exp = /bs\.yandex\.ru\/informer\/(\d+)/;
        var res = exp.exec(req.responseText);
        if (!res)
        {
            exp = /[\.\s]yaCounter(\d+)/;
            res = exp.exec(req.responseText);
        }
        if (res)
        {
            var l = 'https://metrika.yandex.ru/stat/?id=' + res[1] + '&from=informer';
            var i = 'http://bs.yandex.ru/informer/' + res[1] + '/3_0_FFFFFFFF_FFFFFFFF_0_pageviews';
            return {l:l, i:i};
        }
        return null;
    },
    openstat: function(req)
    {
        var exp = /(openstat|spylog)(\d+)/;
        var res = exp.exec(req.responseText);
        if (!res)
        {
            exp = /(spylog)\.com\/cnt\?cid\=(\d+)/i;
            res = exp.exec(req.responseText);
        }
        var l, i;
        if (res)
        {
            l = 'http://rating.openstat.ru/site/' + res[2] + '/';
            i = 'https://openstat.net/digits?cid=' + res[2] + '&ls=0&ln=5083&tc=458efc';
            return {l:l, i:i};
        }
        exp = /u(\d+)\.(\d+)\.spylog\.com/;
        if ((res = exp.exec(req.responseText)) !== null)
        {
            var id = parseInt('' + res[1] + res[2], 10);
            l = 'http://rating.openstat.ru/site/' + id + '/';
            i = 'https://openstat.net/digits?cid=' + id + '&ls=0&ln=5083&tc=458efc';
            return {l:l, i:i};
        }
        return null;
    },
    topmail: function(req)
    {
        var exp = /\.(mail|list)\.ru\/counter\?id\=(\d+)/i;
        var res = exp.exec(req.responseText);
        if (!res)
        {
            exp = /\.(mail|list)\.ru\/jump\?from\=(\d+)/i;
            res = exp.exec(req.responseText);
        }
        if (res)
        {
            var l = 'http://top.mail.ru/rating?id=' + res[2] + '&period=0';
            var i = 'https://top-fwz1.mail.ru/counter?id=' + res[2] + ';t=499;l=1';
            return {l:l, i:i};
        }
        return null;
    },
    hotlog: function(req)
    {
        var exp = /click\.hotlog\.ru\/\?(\d+)/i;
        var res = exp.exec(req.responseText);
        if (!res)
        {
            exp = /hotlog\.ru\/viewstat\?id\=(\d+)/i;
            res = exp.exec(req.responseText);
        }
        if (res)
        {
            var res_2, exp_2 = /hit(\d+).hotlog.ru/i;
            if ((res_2 = exp_2.exec(req.responseText)) !== null)
            {
                var l = 'http://hotlog.ru/viewstat?id=' + res[1];
                var i = 'https://hit' + res_2[1] + '.hotlog.ru/cgi-bin/hotlog/count?s=' + res[1] + '&im=302';
                return {l:l, i:i};
            }
        }
        return null;
    },
    iua: function(req)
    {
        var exp = /r\.i\.ua\/s\?u(\d+)/i;
        var res = exp.exec(req.responseText);
        if (!res)
        {
            exp = /i\.ua\/r\.php\?(\d+)/i;
            res = exp.exec(req.responseText);
        }
        if (res)
        {
            var l = 'http://catalog.i.ua/stat/' + res[1] + '/';
            var i = 'http://r.i.ua/s?u' + res[1] + '&p20&r' + encodeURIComponent(req.channel.URI.asciiHost);
            return {l:l, i:i};
        }
        return null;
    },
    liru: function(req)
    {
        var res, exp = /counter\.yadro\.ru\/hit\?/i;
        var l, i;
        if ((res = exp.exec(req.responseText)) !== null)
        {
            l = 'https://www.liveinternet.ru/stat/' + req.channel.URI.asciiHost + '/';
            i = 'https://counter.yadro.ru/logo;' + req.channel.URI.asciiHost + '?16.1';
            return {l:l, i:i};
        }
        exp = /counter\.yadro\.ru\/hit\;([_a-z0-9]+)\?/i;
        if ((res = exp.exec(req.responseText)) !== null)
        {
            l = 'https://www.liveinternet.ru/stat/' + res[1] + '/';
            i = 'https://counter.yadro.ru/logo;' + res[1] + '?16.1';
            return {l:l, i:i};
        }
        exp = /counter\.yadro\.ru\/logo\;([_a-z0-9]+)/i;
        if ((res = exp.exec(req.responseText)) !== null)
        {
            l = 'https://www.liveinternet.ru/stat/' + res[1] + '/';
            i = 'https://counter.yadro.ru/logo;' + res[1] + '?16.1';
            return {l:l, i:i};
        }
        return null;
    },
    liru_2: function(req)
    {
        var l = 'https://www.liveinternet.ru/stat/' + req.channel.URI.asciiHost + '/';
        var i = 'https://counter.yadro.ru/logo;' + req.channel.URI.asciiHost + '?16.1';
        return {l:l, i:i};
    }
};

sape.counters.replaceImage = function(image)
{
    try
    {
        if (image && image.parentNode && image.parentNode.parentNode)
        {
            var div = image.parentNode.parentNode;
                div.removeChild(image.parentNode);

            var ilink = div.querySelector('.iSapeCounter');
            if (!ilink)
            {
                var hlink = div.querySelector('.iSapeHiddenCounter');
                if (hlink)
                {
                    hlink.className = 'iSapeCounter';
                }
            }
        }
    }
    catch(ex) {}
};

sape.counters.check = function(e)
{
    var st = sape.toolbar, me = sape.counters;
    var image = e.target;
    try
    {
        image.removeEventListener('load', sape.counters.check, false);

        var cnv = me.doc.createElement("canvas");
            cnv.width = 88;
            cnv.height = 31;
            cnv.getContext('2d').drawImage(image,0,0,88,31);

        var hash = st.md5(cnv.toDataURL("image/png", ""));
        if (hash == "90cb7e44965c47272d6e654ce4ded448" || hash == "b2ca165ac20c859cd7b783034a6ce368") me.replaceImage(image);
    }
    catch(ex) {}
};

sape.counters.onerror = function(e)
{
    sape.counters.replaceImage(e.target);
};

sape.counters.next = function(me)
{
      var timeout = (arguments.length > 1)? arguments[1] : 100;
      if (me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};

sape.counters.nextone = function()
{
    var st = sape.toolbar, me = sape.counters;

    if (!me.doc.defaultView) return;

    var rows = me.doc.getElementsByTagName('tr');
    var rl   = rows.length;

    for (var i = me.first; i < rl; i++)
    {
        var crow = rows[i];
        if (crow.hasAttribute('cnt_checked')) continue;

        var col = crow.cells;
        if (col.length < me.lay.cols) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var links = col[me.lc].getElementsByTagName("a");
        if (links.length < me.lay.idx + 1) continue;

        var href = links[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        if (!me.first) me.first = i;

        var place = col[me.lc];
        var url = st.getURI(href).asciiSpec;

        st.antivir(url, col[me.lay.check]);

        var icon = me.doc.createElement('img');
            icon.src = 'chrome://wmsape/skin/ajax-loader.gif';
        var loader = me.doc.createElement('div');
            loader.appendChild(icon);

        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', url, true);
            req.timeout = 30000;

        if (me.anonymous) req.channel.loadFlags |= Components.interfaces.nsIRequest.LOAD_ANONYMOUS;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                place.removeChild(loader);
                if (req.status == 200 && req.responseText.length > 0)
                {
                    var cn = 0, api;

                    var div = me.doc.createElement('div');
                        div.className = 'iSapeCounterDiv';

                    var pURL = req.channel.URI.prePath;

                    for (var j=0; j < me.workers.length; j++)
                    {
                        var worker = me.workers[j];
                        var cached = me.cache[worker][pURL];

                        var res = (cached)? JSON.parse(cached) : me.farm[worker](req);
                        if (res)
                        {
                            var ci = new Image();
                                ci.src = res.i;
                                ci.title = st.str('counters.title.' + worker);
                                ci.addEventListener('error', sape.counters.onerror, false);
                            if (worker.match(/(liru|metrika)/))
                            {
                                ci.addEventListener('load', sape.counters.check, false);
                            }
                            var cl = me.doc.createElement('a');
                                cl.target = '_blank';
                                cl.href = res.l;
                                cl.className = (cn)? 'iSapeHiddenCounter' : 'iSapeCounter';
                                cl.appendChild(ci);

                                div.appendChild(cl);

                            if (!cached)
                            {
                                me.cache[worker][pURL] = JSON.stringify(res);
                            }
                            if (cn > 3) break;
                            cn++;
                        }
                    }
                    place.appendChild(div);
                }
                sape.external.checkRedirect(req, checkbox.parentNode);
                me.next(me);
            }
        };
        place.appendChild(loader);
        crow.setAttribute('cnt_checked', '1');

        try {req.send(null);} catch(e) {req.abort();}
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('counters.finish'), 2, me.img);
    }
};

sape.counters.unload = function()
{
    var me = sape.counters;

    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    for (var j=0; j < me.workers.length; j++)
    {
        me.cache[me.workers[j]] = {};
    }
    me.inProgress = me.doc = 0;
};

sape.counters.start = function()
{
    var st = sape.toolbar, me = sape.counters, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('LI');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('counters.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay   = st.layout(doc);
    var prefs = st.prefs();

    me.skip      = prefs.getBoolPref("re.check");
    me.anonymous = prefs.getBoolPref("anonymous");

    me.doc = doc;
    me.lay = lay;
    me.lc  = (lay.url < 0)? lay.link : lay.url;

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc < 0) return;
    me.first        = 0;
    me.inProgress   = 1;

    for (var j=0; j < me.workers.length; j++)
    {
        me.cache[me.workers[j]] = {};
    }

    st.loadJS('external');
    st.showAlert(st.str('nice'), st.str('counters.start'), 1, me.img);

    var streams = Math.max(1, prefs.getIntPref("streams"));
    for (var i=0; i < streams; i++) me.next(me, 100 + 500*i);
};
