var sape = sape || {};

if (!sape.updates) sape.updates = {};

// -------------------------------------------------------
// Апдейты Яндекса
// -------------------------------------------------------

sape.updates.yandex = {lastup:0, now:0, up:''};

sape.updates.yandex.show = function()
{
    var self = sape.updates.yandex;
    try
    {
        var notifyBox = gBrowser.getNotificationBox();
        if (notifyBox)
        {
            var notify = notifyBox.getNotificationWithValue('yandex-updates-popup');
            if (!notify)
            {
                notify = notifyBox.appendNotification(sape.toolbar.str('attention') + ' ' + sape.toolbar.str('updates.warning') + ' (' + self.up + ')', 'yandex-updates-popup', 'chrome://wmsape/skin/yandex.png', notifyBox.PRIORITY_WARNING_LOW, null);
                notify.setAttribute("tooltiptext", sape.toolbar.str('close'));
                notify.addEventListener("click", self.onClick);
            }
        }
    } catch(err){}
};

sape.updates.yandex.onClick = function(aEvent)
{
    aEvent.target.close();
};

sape.updates.yandex.get = function()
{
    var self = sape.updates.yandex, D = new Date();
    self.now = Math.round(D.getTime() / 1000) + ((D.getTimezoneOffset() + 240) * 60);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', 'http://seobudget.ru/downloads/updates.xml', true);

    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseXML)
            {
                var dates = req.responseXML.querySelectorAll('update[id="serp"] date');
                for (var j=0; j < dates.length; j++)
                {
                    var stamp = parseInt(dates[j].getAttribute("timestamp"), 10);
                    if (stamp > self.lastup)
                    {
                        self.lastup = stamp;
                        self.up = dates[j].textContent;
                    }
                    if ((self.now - self.lastup) < 12 * 60 * 60)
                    {
                        self.show();
                        break;
                    }
                }
            }
        }
    };
    req.send(null);
};

sape.updates.yandex.check = function()
{
    var self = sape.updates.yandex;
    if (!self.lastup)
    {
        self.get();
        return;
    }
    var D = new Date(), now = Math.round(D.getTime() / 1000) + ((D.getTimezoneOffset() + 240) * 60);

    if ((now - self.lastup) < 12 * 60 * 60)
    {
        self.show();
        return;
    }
    if ((now - self.now) >  1 * 60 * 60)
    {
        self.get();
    }
};
